CreateInterfaces proc <0>
LOCAL ParmArea[32]:BYTE
	nop
	invoke DebugCreate,addr IIDebugClient,addr gClient
	invoke IDebugClient.QueryInterface,gClient,addr IIDebugControl,addr gControl
	invoke IDebugClient.QueryInterface,gClient,addr IIDebugDataSpaces,addr gData
	invoke IDebugClient.QueryInterface,gClient,addr IIDebugRegisters,addr gRegisters
	invoke IDebugClient.QueryInterface,gClient,addr IIDebugSymbols,addr gSymbols
	invoke IDebugClient.QueryInterface,gClient,addr IIDebugAdvanced,addr gAdv
	invoke IDebugClient.SetEventCallbacks,gClient,addr DbgEventCallbacks
	invoke CreateEvent,NULL,FALSE,FALSE,NULL
	mov hStepIntoEvent,rax
	ret
CreateInterfaces endp
DeleteInterfaces proc <0>
LOCAL ParmArea[32]:BYTE
	nop
	invoke IDebugDataSpaces.Release,gAdv
	invoke IDebugDataSpaces.Release,gSymbols
	invoke IDebugDataSpaces.Release,gRegisters
	invoke IDebugDataSpaces.Release,gData
	invoke IDebugControl.Release,gControl
	invoke IDebugClient.EndSession,gClient,DEBUG_END_PASSIVE
	invoke IDebugClient.Release,gClient
	invoke CloseHandle,hStepIntoEvent
	ret
DeleteInterfaces endp
LoadDbgeng proc <4> DbgengPath:LPSTR
LOCAL hPathFile:HANDLE
LOCAL DbgengName[MAX_PATH]:CHAR
LOCAL DbghelpName[MAX_PATH]:CHAR
LOCAL CurrentDir[MAX_PATH]:CHAR
LOCAL EngDir[MAX_PATH]:CHAR
LOCAL cRW:DWORD
	mov DbgengPath,rcx
	invoke GetCurrentDirectory,sizeof CurrentDir,addr CurrentDir
	invoke CreateFile,DbgengPath,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0
	.if rax~=INVALID_HANDLE_VALUE
		mov hPathFile,rax
		invoke ReadFile,hPathFile,addr DbgengName,sizeof DbgengName,addr cRW,0
		mov eax,cRW
		mov DbgengName[rax],0
		invoke CloseHandle,hPathFile
		invoke strcpy,addr EngDir,addr DbgengName
		mov edx,'\'
		invoke strrchr,addr EngDir,rdx
		.if rax
			mov bptr [rax+1],0
			invoke SetCurrentDirectory,addr EngDir
			invoke strcpy,addr DbghelpName,addr EngDir
			invoke strcat,addr DbghelpName,"dbghelp.dll"
			invoke LoadLibrary,addr DbghelpName
		.endif
		invoke GetModuleHandle,addr DbgengName
		.if ~rax
			invoke LoadLibrary,addr DbgengName
			.if ~rax
				invoke SetCurrentDirectory,addr CurrentDir
				invoke MessageBox,0,"Can`t open dbgeng.dll",addr AppName,MB_ICONHAND
				xor eax,eax
				ret
			.endif
		.endif
		mov hDbgeng,rax
		invoke GetProcAddress,hDbgeng,"DebugConnect"
		mov DebugConnect,rax
		invoke GetProcAddress,hDbgeng,"DebugCreate"
		mov DebugCreate,rax
		invoke SetCurrentDirectory,addr CurrentDir
	.endif
	ret
LoadDbgeng endp
DbgEventCallbacks LABEL IDebugEventCallbacks
	dq offset EventVtbl	
EventVtbl LABEL PVOID
	dq offset _QueryInterface
	dq offset _AddRef
	dq offset _Release
	dq offset GetInterestMask
	dq offset _Breakpoint
	dq offset _Exception
	dq offset _CreateThread
	dq offset _ExitThread
	dq offset _CreateProcess
	dq offset _ExitProcess
	dq offset _LoadModule
	dq offset UnloadModule
	dq offset SystemError
	dq offset SessionStatus
	dq offset ChangeDebuggeeState
	dq offset ChangeEngineState
	dq offset ChangeSymbolState
DEFINE_GUID(IID_IUnknown,0,0,0,0,0C0h,0,0,0,0,0,046h)
_QueryInterface proc <4> EventCallbacks:PDECALLBACKS,InterfaceId:REFIID,Interface:PVOID
	mov EventCallbacks,rcx
	mov InterfaceId,rdx
	mov Interface,r8
	mov PVOID ptr [r8],0 
	lea rax,IID_IDebugEventCallbacks
	mov r10,[rdx]
	mov r11,[rdx][8]
	.if r10==qword ptr IID_IUnknown
		cmp r11,qword ptr IID_IUnknown[8]
		jz EventAddRef
	.endif
	.if (r10==qword ptr IID_IDebugEventCallbacks && r11==qword ptr IID_IDebugEventCallbacks[8])
EventAddRef:
		mov rax,EventCallbacks
		mov rdx,Interface
		mov [rdx],rax
		invoke _AddRef,EventCallbacks
		return(S_OK)
	.endif
	return(E_NOINTERFACE)
_QueryInterface endp
_AddRef proc <4> EventCallbacks:PDECALLBACKS
	lock inc CntCallbacks
	return(S_OK)
_AddRef endp
_Release proc <4> EventCallbacks:PDECALLBACKS
	mov eax,-1
	lock xadd CntCallbacks,eax
	ret
_Release endp
GetInterestMask proc <4> EventCallbacks:PDECALLBACKS,_Mask:PULONG
	or ULONG ptr [rdx],(DEBUG_EVENT_BREAKPOINT or DEBUG_EVENT_EXCEPTION or DEBUG_EVENT_CREATE_PROCESS \
		or DEBUG_EVENT_LOAD_MODULE or DEBUG_EVENT_SESSION_STATUS)
	return(S_OK)
GetInterestMask endp
TRAP_FLAG	equ 100h
RESUME_FLAG	equ 1000h
_Breakpoint proc <5> uses rsi EventCallbacks:PDECALLBACKS,_Bp:PDBREAK
LOCAL cRW:QWORD
LOCAL CurrBaseText[128]:CHAR
LOCAL InstOffset:ULONG64
LOCAL hDefFile:HANDLE
LOCAL cBuffer[1024]:BYTE
LOCAL ctx:CONTEXT
LOCAL CurrMnem[256]:CHAR
LOCAL CurrInstr[16]:BYTE
LOCAL EntryBpFlags:ULONG
	mov EventCallbacks,rcx
	mov _Bp,rdx
	mov rdx,_Bp
	.if rdx==gEntryBp
		mov RunPressed,FALSE
		invoke IDebugBreakpoint.RemoveFlags,gEntryBp,DEBUG_BREAKPOINT_ENABLED
		invoke IDebugAdvanced.GetThreadContext,gAdv,addr ctx,sizeof ctx
		invoke GetProp,hDbgWindow,addr EbinData
		mov rsi,rax
		invoke IDebugDataSpaces.ReadVirtual,gData,ctx.Rip,\
			EBIN_DATA.CodeBuff[rsi],EBIN_DATA.FileSize[rsi],addr cRW
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rax
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RAX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rbx
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RBX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rcx
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RCX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rdx
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RDX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rdi
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RDI,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rsi
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RSI,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rbp
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RBP,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rsp
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RSP,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R8
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R8,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R9
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R9,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R10
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R10,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R11
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R11,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R12
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R12,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R13
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R13,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R14
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R14,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R15
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R15,WM_SETTEXT,0,addr CurrMnem
		mov rax,ctx.Rip
		mov EBIN_DATA.CurrBase[rsi],rax
		mov EBIN_DATA.CurrOffset[rsi],rax
		invoke IntToStr,addr CurrMnem,addr EBIN_DATA.CurrBase[rsi],16,0
		invoke SendDlgItemMessage,hDbgWindow,IDC_EDT_CURR_OFFSET,WM_SETTEXT,0,addr CurrMnem
		invoke SendDlgItemMessage,hDbgWindow,IDC_EDT_CURR_BASE,WM_SETTEXT,0,addr CurrMnem
		invoke SendMessage,hDbgWindow,WM_DSMOPEN,0,0
		invoke WaitForSingleObject,hStepIntoEvent,INFINITE
		or ctx.EFlags,TRAP_FLAG
		invoke IDebugAdvanced.SetThreadContext,gAdv,addr ctx,sizeof ctx
		mov eax,DEBUG_STATUS_IGNORE_EVENT
		ret
	.endif
	return(DEBUG_STATUS_STEP_OVER)
_Breakpoint endp
_Exception proc <7> uses rsi EventCallbacks:PDECALLBACKS,Exception:PEXCEPTION_RECORD,FirstChance:ULONG
LOCAL InstOffset:ULONG64
LOCAL hDefFile:HANDLE
LOCAL cBuffer[1024]:BYTE
LOCAL cRW:QWORD
LOCAL ctx:CONTEXT
LOCAL CurrMnem[256]:CHAR
LOCAL CurrInstr[16]:BYTE
LOCAL EntryBpFlags:ULONG
	mov Exception,rdx
	mov FirstChance,r8d
	.if FirstChance
		.if RunPressed
			mov eax,EXCEPTION_RECORD.ExceptionCode[rdx]
			.if eax==EXCEPTION_SINGLE_STEP || eax==EXCEPTION_BREAKPOINT
				return(DEBUG_STATUS_GO_HANDLED)
			.endif
			return(DEBUG_STATUS_NO_CHANGE)
		.endif
		invoke IDebugAdvanced.GetThreadContext,gAdv,addr ctx,sizeof ctx
		invoke GetProp,hDbgWindow,addr EbinData
		mov rsi,rax
		invoke IDebugDataSpaces.ReadVirtual,gData,ctx.Rip,\
			EBIN_DATA.CodeBuff[rsi],EBIN_DATA.FileSize[rsi],addr cRW
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rax
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RAX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rbx
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RBX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rcx
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RCX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rdx
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RDX,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rdi
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RDI,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rsi
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RSI,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rbp
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RBP,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._Rsp
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_RSP,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R8
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R8,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R9
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R9,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R10
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R10,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R11
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R11,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R12
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R12,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R13
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R13,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R14
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R14,WM_SETTEXT,0,addr CurrMnem
		invoke sprintf,addr CurrMnem,addr patAddr,16,ctx._R15
		invoke SendDlgItemMessage,hRegsDlg,IDC_EDT_R15,WM_SETTEXT,0,addr CurrMnem
		mov rax,ctx.Rip
		mov EBIN_DATA.CurrBase[rsi],rax
		mov EBIN_DATA.CurrOffset[rsi],rax
		invoke IntToStr,addr CurrMnem,addr EBIN_DATA.CurrBase[rsi],16,0
		invoke SendDlgItemMessage,hDbgWindow,IDC_EDT_CURR_OFFSET,WM_SETTEXT,0,addr CurrMnem
		invoke SendDlgItemMessage,hDbgWindow,IDC_EDT_CURR_BASE,WM_SETTEXT,0,addr CurrMnem
		invoke SendMessage,hDbgWindow,WM_DSMOPEN,0,0
		invoke WaitForSingleObject,hStepIntoEvent,INFINITE
		or ctx.EFlags,TRAP_FLAG
		invoke IDebugAdvanced.SetThreadContext,gAdv,addr ctx,sizeof ctx
		return(DEBUG_STATUS_STEP_OVER)
	.endif
	return(DEBUG_STATUS_NO_CHANGE)
_Exception endp
_CreateThread proc <4> EventCallbacks:PDECALLBACKS,Handle:ULONG64,\
DataOffset:ULONG64,StartOffset:ULONG64
	nop
	return(DEBUG_STATUS_NO_CHANGE)
_CreateThread endp
_ExitThread proc <4> EventCallbacks:PDECALLBACKS,ExitCode:ULONG
	nop
	return(DEBUG_STATUS_NO_CHANGE)
_ExitThread endp
_CreateProcess proc <4> EventCallbacks:PDECALLBACKS,ImageFileHandle:ULONG64,Handle:ULONG64,\
BaseOffset:ULONG64,ModuleSize:ULONG,ModuleName:PCSTR,ImageName:PCSTR,CheckSum:ULONG,TimeDateStamp:ULONG,\
InitialThreadHandle:ULONG64,ThreadDataOffset:ULONG64,StartOffset:ULONG64
LOCAL EntryText[128]:CHAR
	mov EventCallbacks,rcx
	mov ImageFileHandle,rdx
	mov Handle,r8
	mov BaseOffset,r9
	.const
		BpOpcode db 0CCh
	.code
	;invoke IntToStr,addr EntryText,addr StartOffset,16,STD_HEX
	;invoke MessageBox,0,addr EntryText,"DbgEntryPoint",MB_OK
	invoke IDebugControl.AddBreakpoint,gControl,DEBUG_BREAKPOINT_CODE,DEBUG_ANY_ID,addr gEntryBp
	.if rax~=S_OK
		mov gEntryBp,0
		invoke MessageBox,hDbgWindow,"Can`t create an gEntryBp.",addr AppName,MB_ICONHAND
	.else
		invoke IDebugBreakpoint.SetOffset,gEntryBp,StartOffset
		invoke IDebugBreakpoint.AddFlags,gEntryBp,DEBUG_BREAKPOINT_ENABLED
	.endif
	return(DEBUG_STATUS_NO_CHANGE)
_CreateProcess endp
_ExitProcess proc <4> EventCallbacks:PDECALLBACKS,ExitCode:ULONG
	nop
	return(DEBUG_STATUS_NO_CHANGE)
_ExitProcess endp
_LoadModule proc <4> EventCallbacks:PDECALLBACKS,ImageFileHandle:ULONG64,\
BaseOffset:ULONG64,ModuleSize:ULONG,ModuleName:PCSTR,ImageName:PCSTR,CheckSum:ULONG,TimeDateStamp:ULONG
	nop
	return(DEBUG_STATUS_GO)
_LoadModule endp
UnloadModule proc <4> EventCallbacks:PDECALLBACKS,ImageBaseName:PCSTR,BaseOffset:ULONG64
	nop
	return(DEBUG_STATUS_NO_CHANGE)
UnloadModule endp
SystemError proc <4> EventCallbacks:PDECALLBACKS,Error:ULONG,Level:ULONG
	nop
	return(DEBUG_STATUS_NO_CHANGE)
SystemError endp
SessionStatus proc <4> EventCallbacks:PDECALLBACKS,Status:ULONG
LOCAL SessionStatusText[128]:CHAR
LOCAL SesStatus:ULONG64
	nop
	return(S_OK)
SessionStatus endp
ChangeDebuggeeState proc <4> EventCallbacks:PDECALLBACKS,Flags:ULONG,Argument:ULONG64
	nop
	return(S_OK)
ChangeDebuggeeState endp
ChangeEngineState proc <4> EventCallbacks:PDECALLBACKS,Flags:ULONG,Argument:ULONG64
	nop
	return(S_OK)
ChangeEngineState endp
ChangeSymbolState proc <4> EventCallbacks:PDECALLBACKS,Flags:ULONG,Argument:ULONG64
	nop
	return(S_OK)
ChangeSymbolState endp